/*
Code automatically generated by asn1scc tool
*/
#include <limits.h>
#include <string.h>
#include <math.h>
#include "type.h"


const asn1SccT_UInt32 maxFloatSequenceLength = 327680;
const asn1SccT_UInt32 maxInt64SequenceLength = 327680;
const asn1SccT_UInt32 maxInt32SequenceLength = 327680;
const asn1SccT_UInt32 maxStringSequenceLength = 100;


void asn1SccInt32Sequence_Initialize(asn1SccInt32Sequence* pVal)
{
    int i1;

	i1 = 0;
	while (i1< 327680) {
	    asn1SccT_Int32_Initialize((&(pVal->arr[i1])));
	    i1 = i1 + 1;
	}
	pVal->nCount = 0;
}

flag asn1SccInt32Sequence_IsConstraintValid(const asn1SccInt32Sequence *pVal, int* pErrCode)
{
    flag ret = TRUE;
    int i1;
	
    ret = ((0 <= pVal->nCount) && (pVal->nCount <= 327680));
    *pErrCode = ret ? 0 :  ERR_INT32SEQUENCE;
    for(i1 = 0; ret && i1 < pVal->nCount; i1++) 
    {
    	ret = ((-2147483648LL <= pVal->arr[i1]) && (pVal->arr[i1] <= 2147483647LL));
    	*pErrCode = ret ? 0 :  ERR_INT32SEQUENCE_ELM;
    }


	return ret;
}

flag asn1SccInt32Sequence_Encode(const asn1SccInt32Sequence* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;
	int i1;
	asn1SccSint nBlockIndex1;
	asn1SccSint nRemainingItemsVar1;
	asn1SccSint nCurBlockSize1;
	asn1SccSint nCurOffset1;
	ret = bCheckConstraints ? asn1SccInt32Sequence_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    nRemainingItemsVar1 = pVal->nCount;
	    nCurBlockSize1 = 0;
	    nCurOffset1 = 0;
	    nBlockIndex1 = 0;
	    while (nRemainingItemsVar1 >= 0x4000 && nBlockIndex1 < pVal->nCount) 
	    {
	    	if (nRemainingItemsVar1 >= 0x10000)
	    	{
	    		nCurBlockSize1 = 0x10000;
	    		BitStream_EncodeConstraintWholeNumber(pBitStrm, 0xC4, 0, 0xFF); 
	    	}
	    	else if (nRemainingItemsVar1 >= 0xC000)
	    	{
	    		nCurBlockSize1 = 0xC000;
	    		BitStream_EncodeConstraintWholeNumber(pBitStrm, 0xC3, 0, 0xFF); 
	    	}
	    	else if (nRemainingItemsVar1 >= 0x8000)
	    	{
	    		nCurBlockSize1 = 0x8000;
	    		BitStream_EncodeConstraintWholeNumber(pBitStrm, 0xC2, 0, 0xFF); 
	    	}
	    	else 
	    	{
	    		nCurBlockSize1 = 0x4000;
	    		BitStream_EncodeConstraintWholeNumber(pBitStrm, 0xC1, 0, 0xFF); 
	    	}
	    	
	    	for(i1=(int)nCurOffset1; i1 < (int)(nCurBlockSize1 + nCurOffset1); i1++)
	    	{
	    		ret = asn1SccT_Int32_Encode((&(pVal->arr[i1])), pBitStrm, pErrCode, FALSE);
	    	}
	    	nCurOffset1 += nCurBlockSize1;
	    	nRemainingItemsVar1 -= nCurBlockSize1;
	        nBlockIndex1 = nBlockIndex1+1;
	    }

	    if (nRemainingItemsVar1 <= 0x7F)
	    	BitStream_EncodeConstraintWholeNumber(pBitStrm, nRemainingItemsVar1, 0, 0xFF);
	    else
	    {
	    	BitStream_AppendBit(pBitStrm, 1);
	    	BitStream_EncodeConstraintWholeNumber(pBitStrm, nRemainingItemsVar1, 0, 0x7FFF);
	    }

	    for(i1=(int)nCurOffset1; i1 < (int)(nCurOffset1 + nRemainingItemsVar1); i1++)
	    {
	    	ret = asn1SccT_Int32_Encode((&(pVal->arr[i1])), pBitStrm, pErrCode, FALSE);
	    }
    }

	
    return ret;
}

flag asn1SccInt32Sequence_Decode(asn1SccInt32Sequence* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;
	int i1;
	asn1SccSint nLengthTmp1;
	asn1SccSint nRemainingItemsVar1;
	asn1SccSint nCurBlockSize1;
	asn1SccSint nCurOffset1;

	nRemainingItemsVar1 = 0;
	nCurBlockSize1 = 0;
	nCurOffset1 = 0;
	nLengthTmp1 = 0;
	ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, &nRemainingItemsVar1, 0, 0xFF);
	*pErrCode = ret ? 0 : ERR_UPER_DECODE_INT32SEQUENCE;
	if (ret) {
		while(ret && (nRemainingItemsVar1 & 0xC0)==0xC0) 
		{
			if (nRemainingItemsVar1 == 0xC4)
				nCurBlockSize1 = 0x10000;
			else if (nRemainingItemsVar1 == 0xC3)
				nCurBlockSize1 = 0xC000;
			else if (nRemainingItemsVar1 == 0xC2)
				nCurBlockSize1 = 0x8000;
			else if (nRemainingItemsVar1 == 0xC1)
				nCurBlockSize1 = 0x4000;
			else {
				*pErrCode = ERR_UPER_DECODE_INT32SEQUENCE;
				return FALSE;
			}
			if (nCurOffset1 + nCurBlockSize1 > 327680)
			{
				*pErrCode = ERR_UPER_DECODE_INT32SEQUENCE;
				return FALSE;
			}

			for(i1=(int)nCurOffset1; ret && (i1 < (int)(nCurOffset1 + nCurBlockSize1)) ; i1++)
			{
				ret = asn1SccT_Int32_Decode((&(pVal->arr[i1])), pBitStrm, pErrCode);
			}
		
	        if (ret) {
			    nLengthTmp1 += (long)nCurBlockSize1;
			    nCurOffset1 += nCurBlockSize1;
			    ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, &nRemainingItemsVar1, 0, 0xFF);
	            *pErrCode = ret ? 0 : ERR_UPER_DECODE_INT32SEQUENCE;
	        }
		}
	    if (ret) {
		    if ( (nRemainingItemsVar1 & 0x80)>0) 
		    {
			    asn1SccSint len2;
			    nRemainingItemsVar1 <<= 8;
			    ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, &len2, 0, 0xFF);
	            *pErrCode = ret ? 0 : ERR_UPER_DECODE_INT32SEQUENCE;
	            if (ret) {
			        nRemainingItemsVar1 |= len2;
			        nRemainingItemsVar1 &= 0x7FFF;
	            }
		    }
	        ret = ret && (nCurOffset1 + nRemainingItemsVar1 <= 327680);
	        *pErrCode = ret ? 0 : ERR_UPER_DECODE_INT32SEQUENCE;
	        if (ret) {
		        for(i1=(int)nCurOffset1; ret && (i1 < (int)(nCurOffset1 + nRemainingItemsVar1)) ; i1++)
		        {
			        ret = asn1SccT_Int32_Decode((&(pVal->arr[i1])), pBitStrm, pErrCode);
		        }
	            if (ret) {
		            nLengthTmp1 += (long)nRemainingItemsVar1;

	                if ((nLengthTmp1 >= 0) && (nLengthTmp1 <= 327680)) {
		                pVal->nCount = (int)nLengthTmp1;

	                } else {
	                    ret = FALSE;
	                    *pErrCode = ERR_UPER_DECODE_INT32SEQUENCE;
	                }

	            }
	        }
	    }
	}

	return ret  && asn1SccInt32Sequence_IsConstraintValid(pVal, pErrCode);
}

flag asn1SccInt32Sequence_ACN_Encode(const asn1SccInt32Sequence* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;
	int i1;
	asn1SccSint nBlockIndex1;
	asn1SccSint nRemainingItemsVar1;
	asn1SccSint nCurBlockSize1;
	asn1SccSint nCurOffset1;
	ret = bCheckConstraints ? asn1SccInt32Sequence_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    nRemainingItemsVar1 = pVal->nCount;
	    nCurBlockSize1 = 0;
	    nCurOffset1 = 0;
	    nBlockIndex1 = 0;
	    while (nRemainingItemsVar1 >= 0x4000 && nBlockIndex1 < pVal->nCount) 
	    {
	    	if (nRemainingItemsVar1 >= 0x10000)
	    	{
	    		nCurBlockSize1 = 0x10000;
	    		BitStream_EncodeConstraintWholeNumber(pBitStrm, 0xC4, 0, 0xFF); 
	    	}
	    	else if (nRemainingItemsVar1 >= 0xC000)
	    	{
	    		nCurBlockSize1 = 0xC000;
	    		BitStream_EncodeConstraintWholeNumber(pBitStrm, 0xC3, 0, 0xFF); 
	    	}
	    	else if (nRemainingItemsVar1 >= 0x8000)
	    	{
	    		nCurBlockSize1 = 0x8000;
	    		BitStream_EncodeConstraintWholeNumber(pBitStrm, 0xC2, 0, 0xFF); 
	    	}
	    	else 
	    	{
	    		nCurBlockSize1 = 0x4000;
	    		BitStream_EncodeConstraintWholeNumber(pBitStrm, 0xC1, 0, 0xFF); 
	    	}
	    	
	    	for(i1=(int)nCurOffset1; i1 < (int)(nCurBlockSize1 + nCurOffset1); i1++)
	    	{
	    		BitStream_EncodeConstraintWholeNumber(pBitStrm, pVal->arr[i1], -2147483648LL, 2147483647LL);
	    	}
	    	nCurOffset1 += nCurBlockSize1;
	    	nRemainingItemsVar1 -= nCurBlockSize1;
	        nBlockIndex1 = nBlockIndex1+1;
	    }

	    if (nRemainingItemsVar1 <= 0x7F)
	    	BitStream_EncodeConstraintWholeNumber(pBitStrm, nRemainingItemsVar1, 0, 0xFF);
	    else
	    {
	    	BitStream_AppendBit(pBitStrm, 1);
	    	BitStream_EncodeConstraintWholeNumber(pBitStrm, nRemainingItemsVar1, 0, 0x7FFF);
	    }

	    for(i1=(int)nCurOffset1; i1 < (int)(nCurOffset1 + nRemainingItemsVar1); i1++)
	    {
	    	BitStream_EncodeConstraintWholeNumber(pBitStrm, pVal->arr[i1], -2147483648LL, 2147483647LL);
	    }
    }

	
    return ret;
}

flag asn1SccInt32Sequence_ACN_Decode(asn1SccInt32Sequence* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;
	int i1;
	asn1SccSint nLengthTmp1;
	asn1SccSint nRemainingItemsVar1;
	asn1SccSint nCurBlockSize1;
	asn1SccSint nCurOffset1;

	nRemainingItemsVar1 = 0;
	nCurBlockSize1 = 0;
	nCurOffset1 = 0;
	nLengthTmp1 = 0;
	ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, &nRemainingItemsVar1, 0, 0xFF);
	*pErrCode = ret ? 0 : ERR_ACN_DECODE_INT32SEQUENCE;
	if (ret) {
		while(ret && (nRemainingItemsVar1 & 0xC0)==0xC0) 
		{
			if (nRemainingItemsVar1 == 0xC4)
				nCurBlockSize1 = 0x10000;
			else if (nRemainingItemsVar1 == 0xC3)
				nCurBlockSize1 = 0xC000;
			else if (nRemainingItemsVar1 == 0xC2)
				nCurBlockSize1 = 0x8000;
			else if (nRemainingItemsVar1 == 0xC1)
				nCurBlockSize1 = 0x4000;
			else {
				*pErrCode = ERR_ACN_DECODE_INT32SEQUENCE;
				return FALSE;
			}
			if (nCurOffset1 + nCurBlockSize1 > 327680)
			{
				*pErrCode = ERR_ACN_DECODE_INT32SEQUENCE;
				return FALSE;
			}

			for(i1=(int)nCurOffset1; ret && (i1 < (int)(nCurOffset1 + nCurBlockSize1)) ; i1++)
			{
				ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, (&(pVal->arr[i1])), -2147483648LL, 2147483647LL);
				*pErrCode = ret ? 0 : ERR_ACN_DECODE_INT32SEQUENCE_ELM;
			}
		
	        if (ret) {
			    nLengthTmp1 += (long)nCurBlockSize1;
			    nCurOffset1 += nCurBlockSize1;
			    ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, &nRemainingItemsVar1, 0, 0xFF);
	            *pErrCode = ret ? 0 : ERR_ACN_DECODE_INT32SEQUENCE;
	        }
		}
	    if (ret) {
		    if ( (nRemainingItemsVar1 & 0x80)>0) 
		    {
			    asn1SccSint len2;
			    nRemainingItemsVar1 <<= 8;
			    ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, &len2, 0, 0xFF);
	            *pErrCode = ret ? 0 : ERR_ACN_DECODE_INT32SEQUENCE;
	            if (ret) {
			        nRemainingItemsVar1 |= len2;
			        nRemainingItemsVar1 &= 0x7FFF;
	            }
		    }
	        ret = ret && (nCurOffset1 + nRemainingItemsVar1 <= 327680);
	        *pErrCode = ret ? 0 : ERR_ACN_DECODE_INT32SEQUENCE;
	        if (ret) {
		        for(i1=(int)nCurOffset1; ret && (i1 < (int)(nCurOffset1 + nRemainingItemsVar1)) ; i1++)
		        {
			        ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, (&(pVal->arr[i1])), -2147483648LL, 2147483647LL);
			        *pErrCode = ret ? 0 : ERR_ACN_DECODE_INT32SEQUENCE_ELM;
		        }
	            if (ret) {
		            nLengthTmp1 += (long)nRemainingItemsVar1;

	                if ((nLengthTmp1 >= 0) && (nLengthTmp1 <= 327680)) {
		                pVal->nCount = (int)nLengthTmp1;

	                } else {
	                    ret = FALSE;
	                    *pErrCode = ERR_ACN_DECODE_INT32SEQUENCE;
	                }

	            }
	        }
	    }
	}

    return ret && asn1SccInt32Sequence_IsConstraintValid(pVal, pErrCode);
}



void asn1SccInt64Sequence_Initialize(asn1SccInt64Sequence* pVal)
{
    int i1;

	i1 = 0;
	while (i1< 327680) {
	    asn1SccT_Int64_Initialize((&(pVal->arr[i1])));
	    i1 = i1 + 1;
	}
	pVal->nCount = 0;
}

flag asn1SccInt64Sequence_IsConstraintValid(const asn1SccInt64Sequence *pVal, int* pErrCode)
{
    flag ret = TRUE;
    int i1;
	
    ret = ((0 <= pVal->nCount) && (pVal->nCount <= 327680));
    *pErrCode = ret ? 0 :  ERR_INT64SEQUENCE;
    for(i1 = 0; ret && i1 < pVal->nCount; i1++) 
    {
    	ret = (-9223372036854775807LL <= pVal->arr[i1]);
    	*pErrCode = ret ? 0 :  ERR_INT64SEQUENCE_ELM;
    }


	return ret;
}

flag asn1SccInt64Sequence_Encode(const asn1SccInt64Sequence* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;
	int i1;
	asn1SccSint nBlockIndex1;
	asn1SccSint nRemainingItemsVar1;
	asn1SccSint nCurBlockSize1;
	asn1SccSint nCurOffset1;
	ret = bCheckConstraints ? asn1SccInt64Sequence_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    nRemainingItemsVar1 = pVal->nCount;
	    nCurBlockSize1 = 0;
	    nCurOffset1 = 0;
	    nBlockIndex1 = 0;
	    while (nRemainingItemsVar1 >= 0x4000 && nBlockIndex1 < pVal->nCount) 
	    {
	    	if (nRemainingItemsVar1 >= 0x10000)
	    	{
	    		nCurBlockSize1 = 0x10000;
	    		BitStream_EncodeConstraintWholeNumber(pBitStrm, 0xC4, 0, 0xFF); 
	    	}
	    	else if (nRemainingItemsVar1 >= 0xC000)
	    	{
	    		nCurBlockSize1 = 0xC000;
	    		BitStream_EncodeConstraintWholeNumber(pBitStrm, 0xC3, 0, 0xFF); 
	    	}
	    	else if (nRemainingItemsVar1 >= 0x8000)
	    	{
	    		nCurBlockSize1 = 0x8000;
	    		BitStream_EncodeConstraintWholeNumber(pBitStrm, 0xC2, 0, 0xFF); 
	    	}
	    	else 
	    	{
	    		nCurBlockSize1 = 0x4000;
	    		BitStream_EncodeConstraintWholeNumber(pBitStrm, 0xC1, 0, 0xFF); 
	    	}
	    	
	    	for(i1=(int)nCurOffset1; i1 < (int)(nCurBlockSize1 + nCurOffset1); i1++)
	    	{
	    		ret = asn1SccT_Int64_Encode((&(pVal->arr[i1])), pBitStrm, pErrCode, FALSE);
	    	}
	    	nCurOffset1 += nCurBlockSize1;
	    	nRemainingItemsVar1 -= nCurBlockSize1;
	        nBlockIndex1 = nBlockIndex1+1;
	    }

	    if (nRemainingItemsVar1 <= 0x7F)
	    	BitStream_EncodeConstraintWholeNumber(pBitStrm, nRemainingItemsVar1, 0, 0xFF);
	    else
	    {
	    	BitStream_AppendBit(pBitStrm, 1);
	    	BitStream_EncodeConstraintWholeNumber(pBitStrm, nRemainingItemsVar1, 0, 0x7FFF);
	    }

	    for(i1=(int)nCurOffset1; i1 < (int)(nCurOffset1 + nRemainingItemsVar1); i1++)
	    {
	    	ret = asn1SccT_Int64_Encode((&(pVal->arr[i1])), pBitStrm, pErrCode, FALSE);
	    }
    }

	
    return ret;
}

flag asn1SccInt64Sequence_Decode(asn1SccInt64Sequence* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;
	int i1;
	asn1SccSint nLengthTmp1;
	asn1SccSint nRemainingItemsVar1;
	asn1SccSint nCurBlockSize1;
	asn1SccSint nCurOffset1;

	nRemainingItemsVar1 = 0;
	nCurBlockSize1 = 0;
	nCurOffset1 = 0;
	nLengthTmp1 = 0;
	ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, &nRemainingItemsVar1, 0, 0xFF);
	*pErrCode = ret ? 0 : ERR_UPER_DECODE_INT64SEQUENCE;
	if (ret) {
		while(ret && (nRemainingItemsVar1 & 0xC0)==0xC0) 
		{
			if (nRemainingItemsVar1 == 0xC4)
				nCurBlockSize1 = 0x10000;
			else if (nRemainingItemsVar1 == 0xC3)
				nCurBlockSize1 = 0xC000;
			else if (nRemainingItemsVar1 == 0xC2)
				nCurBlockSize1 = 0x8000;
			else if (nRemainingItemsVar1 == 0xC1)
				nCurBlockSize1 = 0x4000;
			else {
				*pErrCode = ERR_UPER_DECODE_INT64SEQUENCE;
				return FALSE;
			}
			if (nCurOffset1 + nCurBlockSize1 > 327680)
			{
				*pErrCode = ERR_UPER_DECODE_INT64SEQUENCE;
				return FALSE;
			}

			for(i1=(int)nCurOffset1; ret && (i1 < (int)(nCurOffset1 + nCurBlockSize1)) ; i1++)
			{
				ret = asn1SccT_Int64_Decode((&(pVal->arr[i1])), pBitStrm, pErrCode);
			}
		
	        if (ret) {
			    nLengthTmp1 += (long)nCurBlockSize1;
			    nCurOffset1 += nCurBlockSize1;
			    ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, &nRemainingItemsVar1, 0, 0xFF);
	            *pErrCode = ret ? 0 : ERR_UPER_DECODE_INT64SEQUENCE;
	        }
		}
	    if (ret) {
		    if ( (nRemainingItemsVar1 & 0x80)>0) 
		    {
			    asn1SccSint len2;
			    nRemainingItemsVar1 <<= 8;
			    ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, &len2, 0, 0xFF);
	            *pErrCode = ret ? 0 : ERR_UPER_DECODE_INT64SEQUENCE;
	            if (ret) {
			        nRemainingItemsVar1 |= len2;
			        nRemainingItemsVar1 &= 0x7FFF;
	            }
		    }
	        ret = ret && (nCurOffset1 + nRemainingItemsVar1 <= 327680);
	        *pErrCode = ret ? 0 : ERR_UPER_DECODE_INT64SEQUENCE;
	        if (ret) {
		        for(i1=(int)nCurOffset1; ret && (i1 < (int)(nCurOffset1 + nRemainingItemsVar1)) ; i1++)
		        {
			        ret = asn1SccT_Int64_Decode((&(pVal->arr[i1])), pBitStrm, pErrCode);
		        }
	            if (ret) {
		            nLengthTmp1 += (long)nRemainingItemsVar1;

	                if ((nLengthTmp1 >= 0) && (nLengthTmp1 <= 327680)) {
		                pVal->nCount = (int)nLengthTmp1;

	                } else {
	                    ret = FALSE;
	                    *pErrCode = ERR_UPER_DECODE_INT64SEQUENCE;
	                }

	            }
	        }
	    }
	}

	return ret  && asn1SccInt64Sequence_IsConstraintValid(pVal, pErrCode);
}

flag asn1SccInt64Sequence_ACN_Encode(const asn1SccInt64Sequence* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;
	int i1;
	asn1SccSint nBlockIndex1;
	asn1SccSint nRemainingItemsVar1;
	asn1SccSint nCurBlockSize1;
	asn1SccSint nCurOffset1;
	ret = bCheckConstraints ? asn1SccInt64Sequence_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    nRemainingItemsVar1 = pVal->nCount;
	    nCurBlockSize1 = 0;
	    nCurOffset1 = 0;
	    nBlockIndex1 = 0;
	    while (nRemainingItemsVar1 >= 0x4000 && nBlockIndex1 < pVal->nCount) 
	    {
	    	if (nRemainingItemsVar1 >= 0x10000)
	    	{
	    		nCurBlockSize1 = 0x10000;
	    		BitStream_EncodeConstraintWholeNumber(pBitStrm, 0xC4, 0, 0xFF); 
	    	}
	    	else if (nRemainingItemsVar1 >= 0xC000)
	    	{
	    		nCurBlockSize1 = 0xC000;
	    		BitStream_EncodeConstraintWholeNumber(pBitStrm, 0xC3, 0, 0xFF); 
	    	}
	    	else if (nRemainingItemsVar1 >= 0x8000)
	    	{
	    		nCurBlockSize1 = 0x8000;
	    		BitStream_EncodeConstraintWholeNumber(pBitStrm, 0xC2, 0, 0xFF); 
	    	}
	    	else 
	    	{
	    		nCurBlockSize1 = 0x4000;
	    		BitStream_EncodeConstraintWholeNumber(pBitStrm, 0xC1, 0, 0xFF); 
	    	}
	    	
	    	for(i1=(int)nCurOffset1; i1 < (int)(nCurBlockSize1 + nCurOffset1); i1++)
	    	{
	    		BitStream_EncodeConstraintWholeNumber(pBitStrm, pVal->arr[i1], -9223372036854775807LL, 9223372036854775807LL);
	    	}
	    	nCurOffset1 += nCurBlockSize1;
	    	nRemainingItemsVar1 -= nCurBlockSize1;
	        nBlockIndex1 = nBlockIndex1+1;
	    }

	    if (nRemainingItemsVar1 <= 0x7F)
	    	BitStream_EncodeConstraintWholeNumber(pBitStrm, nRemainingItemsVar1, 0, 0xFF);
	    else
	    {
	    	BitStream_AppendBit(pBitStrm, 1);
	    	BitStream_EncodeConstraintWholeNumber(pBitStrm, nRemainingItemsVar1, 0, 0x7FFF);
	    }

	    for(i1=(int)nCurOffset1; i1 < (int)(nCurOffset1 + nRemainingItemsVar1); i1++)
	    {
	    	BitStream_EncodeConstraintWholeNumber(pBitStrm, pVal->arr[i1], -9223372036854775807LL, 9223372036854775807LL);
	    }
    }

	
    return ret;
}

flag asn1SccInt64Sequence_ACN_Decode(asn1SccInt64Sequence* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;
	int i1;
	asn1SccSint nLengthTmp1;
	asn1SccSint nRemainingItemsVar1;
	asn1SccSint nCurBlockSize1;
	asn1SccSint nCurOffset1;

	nRemainingItemsVar1 = 0;
	nCurBlockSize1 = 0;
	nCurOffset1 = 0;
	nLengthTmp1 = 0;
	ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, &nRemainingItemsVar1, 0, 0xFF);
	*pErrCode = ret ? 0 : ERR_ACN_DECODE_INT64SEQUENCE;
	if (ret) {
		while(ret && (nRemainingItemsVar1 & 0xC0)==0xC0) 
		{
			if (nRemainingItemsVar1 == 0xC4)
				nCurBlockSize1 = 0x10000;
			else if (nRemainingItemsVar1 == 0xC3)
				nCurBlockSize1 = 0xC000;
			else if (nRemainingItemsVar1 == 0xC2)
				nCurBlockSize1 = 0x8000;
			else if (nRemainingItemsVar1 == 0xC1)
				nCurBlockSize1 = 0x4000;
			else {
				*pErrCode = ERR_ACN_DECODE_INT64SEQUENCE;
				return FALSE;
			}
			if (nCurOffset1 + nCurBlockSize1 > 327680)
			{
				*pErrCode = ERR_ACN_DECODE_INT64SEQUENCE;
				return FALSE;
			}

			for(i1=(int)nCurOffset1; ret && (i1 < (int)(nCurOffset1 + nCurBlockSize1)) ; i1++)
			{
				ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, (&(pVal->arr[i1])), -9223372036854775807LL, 9223372036854775807LL);
				*pErrCode = ret ? 0 : ERR_ACN_DECODE_INT64SEQUENCE_ELM;
			}
		
	        if (ret) {
			    nLengthTmp1 += (long)nCurBlockSize1;
			    nCurOffset1 += nCurBlockSize1;
			    ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, &nRemainingItemsVar1, 0, 0xFF);
	            *pErrCode = ret ? 0 : ERR_ACN_DECODE_INT64SEQUENCE;
	        }
		}
	    if (ret) {
		    if ( (nRemainingItemsVar1 & 0x80)>0) 
		    {
			    asn1SccSint len2;
			    nRemainingItemsVar1 <<= 8;
			    ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, &len2, 0, 0xFF);
	            *pErrCode = ret ? 0 : ERR_ACN_DECODE_INT64SEQUENCE;
	            if (ret) {
			        nRemainingItemsVar1 |= len2;
			        nRemainingItemsVar1 &= 0x7FFF;
	            }
		    }
	        ret = ret && (nCurOffset1 + nRemainingItemsVar1 <= 327680);
	        *pErrCode = ret ? 0 : ERR_ACN_DECODE_INT64SEQUENCE;
	        if (ret) {
		        for(i1=(int)nCurOffset1; ret && (i1 < (int)(nCurOffset1 + nRemainingItemsVar1)) ; i1++)
		        {
			        ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, (&(pVal->arr[i1])), -9223372036854775807LL, 9223372036854775807LL);
			        *pErrCode = ret ? 0 : ERR_ACN_DECODE_INT64SEQUENCE_ELM;
		        }
	            if (ret) {
		            nLengthTmp1 += (long)nRemainingItemsVar1;

	                if ((nLengthTmp1 >= 0) && (nLengthTmp1 <= 327680)) {
		                pVal->nCount = (int)nLengthTmp1;

	                } else {
	                    ret = FALSE;
	                    *pErrCode = ERR_ACN_DECODE_INT64SEQUENCE;
	                }

	            }
	        }
	    }
	}

    return ret && asn1SccInt64Sequence_IsConstraintValid(pVal, pErrCode);
}



void asn1SccFloatSequence_Initialize(asn1SccFloatSequence* pVal)
{
    int i1;

	i1 = 0;
	while (i1< 327680) {
	    asn1SccT_Float_Initialize((&(pVal->arr[i1])));
	    i1 = i1 + 1;
	}
	pVal->nCount = 0;
}

flag asn1SccFloatSequence_IsConstraintValid(const asn1SccFloatSequence *pVal, int* pErrCode)
{
    flag ret = TRUE;
    int i1;
	
    ret = ((0 <= pVal->nCount) && (pVal->nCount <= 327680));
    *pErrCode = ret ? 0 :  ERR_FLOATSEQUENCE;
    for(i1 = 0; ret && i1 < pVal->nCount; i1++) 
    {
    	ret = ((-3.40282346600000020000E+038 <= pVal->arr[i1]) && (pVal->arr[i1] <= 3.40282346600000020000E+038));
    	*pErrCode = ret ? 0 :  ERR_FLOATSEQUENCE_ELM;
    }


	return ret;
}

flag asn1SccFloatSequence_Encode(const asn1SccFloatSequence* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;
	int i1;
	asn1SccSint nBlockIndex1;
	asn1SccSint nRemainingItemsVar1;
	asn1SccSint nCurBlockSize1;
	asn1SccSint nCurOffset1;
	ret = bCheckConstraints ? asn1SccFloatSequence_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    nRemainingItemsVar1 = pVal->nCount;
	    nCurBlockSize1 = 0;
	    nCurOffset1 = 0;
	    nBlockIndex1 = 0;
	    while (nRemainingItemsVar1 >= 0x4000 && nBlockIndex1 < pVal->nCount) 
	    {
	    	if (nRemainingItemsVar1 >= 0x10000)
	    	{
	    		nCurBlockSize1 = 0x10000;
	    		BitStream_EncodeConstraintWholeNumber(pBitStrm, 0xC4, 0, 0xFF); 
	    	}
	    	else if (nRemainingItemsVar1 >= 0xC000)
	    	{
	    		nCurBlockSize1 = 0xC000;
	    		BitStream_EncodeConstraintWholeNumber(pBitStrm, 0xC3, 0, 0xFF); 
	    	}
	    	else if (nRemainingItemsVar1 >= 0x8000)
	    	{
	    		nCurBlockSize1 = 0x8000;
	    		BitStream_EncodeConstraintWholeNumber(pBitStrm, 0xC2, 0, 0xFF); 
	    	}
	    	else 
	    	{
	    		nCurBlockSize1 = 0x4000;
	    		BitStream_EncodeConstraintWholeNumber(pBitStrm, 0xC1, 0, 0xFF); 
	    	}
	    	
	    	for(i1=(int)nCurOffset1; i1 < (int)(nCurBlockSize1 + nCurOffset1); i1++)
	    	{
	    		ret = asn1SccT_Float_Encode((&(pVal->arr[i1])), pBitStrm, pErrCode, FALSE);
	    	}
	    	nCurOffset1 += nCurBlockSize1;
	    	nRemainingItemsVar1 -= nCurBlockSize1;
	        nBlockIndex1 = nBlockIndex1+1;
	    }

	    if (nRemainingItemsVar1 <= 0x7F)
	    	BitStream_EncodeConstraintWholeNumber(pBitStrm, nRemainingItemsVar1, 0, 0xFF);
	    else
	    {
	    	BitStream_AppendBit(pBitStrm, 1);
	    	BitStream_EncodeConstraintWholeNumber(pBitStrm, nRemainingItemsVar1, 0, 0x7FFF);
	    }

	    for(i1=(int)nCurOffset1; i1 < (int)(nCurOffset1 + nRemainingItemsVar1); i1++)
	    {
	    	ret = asn1SccT_Float_Encode((&(pVal->arr[i1])), pBitStrm, pErrCode, FALSE);
	    }
    }

	
    return ret;
}

flag asn1SccFloatSequence_Decode(asn1SccFloatSequence* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;
	int i1;
	asn1SccSint nLengthTmp1;
	asn1SccSint nRemainingItemsVar1;
	asn1SccSint nCurBlockSize1;
	asn1SccSint nCurOffset1;

	nRemainingItemsVar1 = 0;
	nCurBlockSize1 = 0;
	nCurOffset1 = 0;
	nLengthTmp1 = 0;
	ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, &nRemainingItemsVar1, 0, 0xFF);
	*pErrCode = ret ? 0 : ERR_UPER_DECODE_FLOATSEQUENCE;
	if (ret) {
		while(ret && (nRemainingItemsVar1 & 0xC0)==0xC0) 
		{
			if (nRemainingItemsVar1 == 0xC4)
				nCurBlockSize1 = 0x10000;
			else if (nRemainingItemsVar1 == 0xC3)
				nCurBlockSize1 = 0xC000;
			else if (nRemainingItemsVar1 == 0xC2)
				nCurBlockSize1 = 0x8000;
			else if (nRemainingItemsVar1 == 0xC1)
				nCurBlockSize1 = 0x4000;
			else {
				*pErrCode = ERR_UPER_DECODE_FLOATSEQUENCE;
				return FALSE;
			}
			if (nCurOffset1 + nCurBlockSize1 > 327680)
			{
				*pErrCode = ERR_UPER_DECODE_FLOATSEQUENCE;
				return FALSE;
			}

			for(i1=(int)nCurOffset1; ret && (i1 < (int)(nCurOffset1 + nCurBlockSize1)) ; i1++)
			{
				ret = asn1SccT_Float_Decode((&(pVal->arr[i1])), pBitStrm, pErrCode);
			}
		
	        if (ret) {
			    nLengthTmp1 += (long)nCurBlockSize1;
			    nCurOffset1 += nCurBlockSize1;
			    ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, &nRemainingItemsVar1, 0, 0xFF);
	            *pErrCode = ret ? 0 : ERR_UPER_DECODE_FLOATSEQUENCE;
	        }
		}
	    if (ret) {
		    if ( (nRemainingItemsVar1 & 0x80)>0) 
		    {
			    asn1SccSint len2;
			    nRemainingItemsVar1 <<= 8;
			    ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, &len2, 0, 0xFF);
	            *pErrCode = ret ? 0 : ERR_UPER_DECODE_FLOATSEQUENCE;
	            if (ret) {
			        nRemainingItemsVar1 |= len2;
			        nRemainingItemsVar1 &= 0x7FFF;
	            }
		    }
	        ret = ret && (nCurOffset1 + nRemainingItemsVar1 <= 327680);
	        *pErrCode = ret ? 0 : ERR_UPER_DECODE_FLOATSEQUENCE;
	        if (ret) {
		        for(i1=(int)nCurOffset1; ret && (i1 < (int)(nCurOffset1 + nRemainingItemsVar1)) ; i1++)
		        {
			        ret = asn1SccT_Float_Decode((&(pVal->arr[i1])), pBitStrm, pErrCode);
		        }
	            if (ret) {
		            nLengthTmp1 += (long)nRemainingItemsVar1;

	                if ((nLengthTmp1 >= 0) && (nLengthTmp1 <= 327680)) {
		                pVal->nCount = (int)nLengthTmp1;

	                } else {
	                    ret = FALSE;
	                    *pErrCode = ERR_UPER_DECODE_FLOATSEQUENCE;
	                }

	            }
	        }
	    }
	}

	return ret  && asn1SccFloatSequence_IsConstraintValid(pVal, pErrCode);
}

flag asn1SccFloatSequence_ACN_Encode(const asn1SccFloatSequence* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;
	int i1;
	asn1SccSint nBlockIndex1;
	asn1SccSint nRemainingItemsVar1;
	asn1SccSint nCurBlockSize1;
	asn1SccSint nCurOffset1;
	ret = bCheckConstraints ? asn1SccFloatSequence_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    nRemainingItemsVar1 = pVal->nCount;
	    nCurBlockSize1 = 0;
	    nCurOffset1 = 0;
	    nBlockIndex1 = 0;
	    while (nRemainingItemsVar1 >= 0x4000 && nBlockIndex1 < pVal->nCount) 
	    {
	    	if (nRemainingItemsVar1 >= 0x10000)
	    	{
	    		nCurBlockSize1 = 0x10000;
	    		BitStream_EncodeConstraintWholeNumber(pBitStrm, 0xC4, 0, 0xFF); 
	    	}
	    	else if (nRemainingItemsVar1 >= 0xC000)
	    	{
	    		nCurBlockSize1 = 0xC000;
	    		BitStream_EncodeConstraintWholeNumber(pBitStrm, 0xC3, 0, 0xFF); 
	    	}
	    	else if (nRemainingItemsVar1 >= 0x8000)
	    	{
	    		nCurBlockSize1 = 0x8000;
	    		BitStream_EncodeConstraintWholeNumber(pBitStrm, 0xC2, 0, 0xFF); 
	    	}
	    	else 
	    	{
	    		nCurBlockSize1 = 0x4000;
	    		BitStream_EncodeConstraintWholeNumber(pBitStrm, 0xC1, 0, 0xFF); 
	    	}
	    	
	    	for(i1=(int)nCurOffset1; i1 < (int)(nCurBlockSize1 + nCurOffset1); i1++)
	    	{
	    		BitStream_EncodeReal(pBitStrm, pVal->arr[i1]);
	    	}
	    	nCurOffset1 += nCurBlockSize1;
	    	nRemainingItemsVar1 -= nCurBlockSize1;
	        nBlockIndex1 = nBlockIndex1+1;
	    }

	    if (nRemainingItemsVar1 <= 0x7F)
	    	BitStream_EncodeConstraintWholeNumber(pBitStrm, nRemainingItemsVar1, 0, 0xFF);
	    else
	    {
	    	BitStream_AppendBit(pBitStrm, 1);
	    	BitStream_EncodeConstraintWholeNumber(pBitStrm, nRemainingItemsVar1, 0, 0x7FFF);
	    }

	    for(i1=(int)nCurOffset1; i1 < (int)(nCurOffset1 + nRemainingItemsVar1); i1++)
	    {
	    	BitStream_EncodeReal(pBitStrm, pVal->arr[i1]);
	    }
    }

	
    return ret;
}

flag asn1SccFloatSequence_ACN_Decode(asn1SccFloatSequence* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;
	int i1;
	asn1SccSint nLengthTmp1;
	asn1SccSint nRemainingItemsVar1;
	asn1SccSint nCurBlockSize1;
	asn1SccSint nCurOffset1;

	nRemainingItemsVar1 = 0;
	nCurBlockSize1 = 0;
	nCurOffset1 = 0;
	nLengthTmp1 = 0;
	ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, &nRemainingItemsVar1, 0, 0xFF);
	*pErrCode = ret ? 0 : ERR_ACN_DECODE_FLOATSEQUENCE;
	if (ret) {
		while(ret && (nRemainingItemsVar1 & 0xC0)==0xC0) 
		{
			if (nRemainingItemsVar1 == 0xC4)
				nCurBlockSize1 = 0x10000;
			else if (nRemainingItemsVar1 == 0xC3)
				nCurBlockSize1 = 0xC000;
			else if (nRemainingItemsVar1 == 0xC2)
				nCurBlockSize1 = 0x8000;
			else if (nRemainingItemsVar1 == 0xC1)
				nCurBlockSize1 = 0x4000;
			else {
				*pErrCode = ERR_ACN_DECODE_FLOATSEQUENCE;
				return FALSE;
			}
			if (nCurOffset1 + nCurBlockSize1 > 327680)
			{
				*pErrCode = ERR_ACN_DECODE_FLOATSEQUENCE;
				return FALSE;
			}

			for(i1=(int)nCurOffset1; ret && (i1 < (int)(nCurOffset1 + nCurBlockSize1)) ; i1++)
			{
				ret = BitStream_DecodeReal(pBitStrm, (&(pVal->arr[i1])));
				*pErrCode = ret ? 0 : ERR_ACN_DECODE_FLOATSEQUENCE_ELM;
			}
		
	        if (ret) {
			    nLengthTmp1 += (long)nCurBlockSize1;
			    nCurOffset1 += nCurBlockSize1;
			    ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, &nRemainingItemsVar1, 0, 0xFF);
	            *pErrCode = ret ? 0 : ERR_ACN_DECODE_FLOATSEQUENCE;
	        }
		}
	    if (ret) {
		    if ( (nRemainingItemsVar1 & 0x80)>0) 
		    {
			    asn1SccSint len2;
			    nRemainingItemsVar1 <<= 8;
			    ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, &len2, 0, 0xFF);
	            *pErrCode = ret ? 0 : ERR_ACN_DECODE_FLOATSEQUENCE;
	            if (ret) {
			        nRemainingItemsVar1 |= len2;
			        nRemainingItemsVar1 &= 0x7FFF;
	            }
		    }
	        ret = ret && (nCurOffset1 + nRemainingItemsVar1 <= 327680);
	        *pErrCode = ret ? 0 : ERR_ACN_DECODE_FLOATSEQUENCE;
	        if (ret) {
		        for(i1=(int)nCurOffset1; ret && (i1 < (int)(nCurOffset1 + nRemainingItemsVar1)) ; i1++)
		        {
			        ret = BitStream_DecodeReal(pBitStrm, (&(pVal->arr[i1])));
			        *pErrCode = ret ? 0 : ERR_ACN_DECODE_FLOATSEQUENCE_ELM;
		        }
	            if (ret) {
		            nLengthTmp1 += (long)nRemainingItemsVar1;

	                if ((nLengthTmp1 >= 0) && (nLengthTmp1 <= 327680)) {
		                pVal->nCount = (int)nLengthTmp1;

	                } else {
	                    ret = FALSE;
	                    *pErrCode = ERR_ACN_DECODE_FLOATSEQUENCE;
	                }

	            }
	        }
	    }
	}

    return ret && asn1SccFloatSequence_IsConstraintValid(pVal, pErrCode);
}



void asn1SccStringSequence_Initialize(asn1SccStringSequence* pVal)
{
    int i1;

	i1 = 0;
	while (i1< 100) {
	    asn1SccT_String_Initialize((&(pVal->arr[i1])));
	    i1 = i1 + 1;
	}
	pVal->nCount = 0;
}

flag asn1SccStringSequence_IsConstraintValid(const asn1SccStringSequence *pVal, int* pErrCode)
{
    flag ret = TRUE;
    int i1;
	
    ret = ((0 <= pVal->nCount) && (pVal->nCount <= 100));
    *pErrCode = ret ? 0 :  ERR_STRINGSEQUENCE;
    for(i1 = 0; ret && i1 < pVal->nCount; i1++) 
    {
    	ret = ((0 <= pVal->arr[i1].nCount) && (pVal->arr[i1].nCount <= 256));
    	*pErrCode = ret ? 0 :  ERR_STRINGSEQUENCE_ELM;
    }


	return ret;
}

flag asn1SccStringSequence_Encode(const asn1SccStringSequence* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;
	int i1;
	ret = bCheckConstraints ? asn1SccStringSequence_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    BitStream_EncodeConstraintWholeNumber(pBitStrm, pVal->nCount, 0, 100);
	    	
	    for(i1=0; (i1 < (int)pVal->nCount) && ret; i1++) 
	    {
	    	ret = asn1SccT_String_Encode((&(pVal->arr[i1])), pBitStrm, pErrCode, FALSE);
	    }
    }

	
    return ret;
}

flag asn1SccStringSequence_Decode(asn1SccStringSequence* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;
	int i1;
	asn1SccSint nCount;

	ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, &nCount, 0, 100);
	*pErrCode = ret ? 0 : ERR_UPER_DECODE_STRINGSEQUENCE;
	pVal->nCount = (long)nCount;
		
	for(i1=0; (i1 < (int)pVal->nCount) && ret; i1++) 
	{
		ret = asn1SccT_String_Decode((&(pVal->arr[i1])), pBitStrm, pErrCode);
	}

	return ret  && asn1SccStringSequence_IsConstraintValid(pVal, pErrCode);
}

flag asn1SccStringSequence_ACN_Encode(const asn1SccStringSequence* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;
	int i1;
	int i2;
	ret = bCheckConstraints ? asn1SccStringSequence_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    BitStream_EncodeConstraintWholeNumber(pBitStrm, pVal->nCount, 0, 100);
	    	
	    for(i1=0; (i1 < (int)pVal->nCount) && ret; i1++) 
	    {
	    	BitStream_EncodeConstraintWholeNumber(pBitStrm, pVal->arr[i1].nCount, 0, 256);
	    		
	    	for(i2=0; (i2 < (int)pVal->arr[i1].nCount) && ret; i2++) 
	    	{
	    		BitStream_AppendByte0(pBitStrm, pVal->arr[i1].arr[i2]);
	    	}
	    }
    }

	
    return ret;
}

flag asn1SccStringSequence_ACN_Decode(asn1SccStringSequence* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;
	int i1;
	int i2;
	asn1SccSint nCount;

	ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, &nCount, 0, 100);
	*pErrCode = ret ? 0 : ERR_ACN_DECODE_STRINGSEQUENCE;
	pVal->nCount = (long)nCount;
		
	for(i1=0; (i1 < (int)pVal->nCount) && ret; i1++) 
	{
		ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, &nCount, 0, 256);
		*pErrCode = ret ? 0 : ERR_ACN_DECODE_STRINGSEQUENCE_ELM;
		pVal->arr[i1].nCount = (long)nCount;
			
		for(i2=0; (i2 < (int)pVal->arr[i1].nCount) && ret; i2++) 
		{
			ret = BitStream_ReadByte(pBitStrm, &(pVal->arr[i1].arr[i2])); 
			*pErrCode = ret ? 0 : ERR_ACN_DECODE_STRINGSEQUENCE_ELM;
		}
	}

    return ret && asn1SccStringSequence_IsConstraintValid(pVal, pErrCode);
}

